package logwire.web.bo;

import logwire.core.exceptions.ApplicationException;
import logwire.web.bo.proxy.Proxy;
import logwire.web.service.query.QueryService;
import logwire.web.tenant.TenantProjectService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Map;

@Component
public class BoService {

    @Autowired
    QueryService queryService;

    @Autowired
    TenantProjectService tenantProjectService;

    public Object createBizObject(Class clazz) {
        Map<String, BoRelationDefinition> boRelationDefinitions = (Map<String, BoRelationDefinition>) tenantProjectService.getCurrentProject().getBeansByContainerName(BoRelationBeanContainerBuilder.CONTAINER_NAME);
        BoRelationDefinition boRelationDefinition = boRelationDefinitions.get(clazz.getName());
        if (boRelationDefinition != null) {
            try {
                return Proxy.createObjectOperationProvider(boRelationDefinition, boRelationDefinitions);
            } catch (IllegalAccessException | InstantiationException e) {
                throw ApplicationException.wrap(e);
            }
        }
        return null;
    }
}
