package logwire.web.bo.field.parse;


import logwire.core.bo.annotation.Array;
import logwire.core.bo.annotation.Column;

import java.lang.reflect.Field;

public abstract class FieldParser<T extends logwire.core.meta.model.fields.Field> {
    protected abstract T newField(String name, Field field);

    public T parse(String name, Field field) {
        T newField = newField(name, field);
        setField(newField, field);
        return newField;
    }

    protected void setField(T newField, Field field) {
        if (field.getAnnotation(Column.class) != null) {
            int length = field.getAnnotation(Column.class).length();
            if (length != 0) {
                newField.setLength(length);
            }
        } else if (field.getAnnotation(Array.class) != null) {
            int length = field.getAnnotation(Array.class).length();
            if (length != 0) {
                newField.setLength(length);
            }
        }

    }


}
